
;-----------------------------------------
;   ColorMix.asm 
;
;   based on Petzolds Color1.C from
;	"Programming Windows"
;
;   Translated into assembly 4/2/00 by
;
;   Ron Thomas Ron_Thom@Compuserve.com	
;-----------------------------------------

        .386				; 32 bit when .386 appears before .MODEL
        .model  flat, stdcall
        option  casemap :none

; Includes
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        include \masm32\include\windows.inc

        include \masm32\include\user32.inc
        include \masm32\include\kernel32.inc
        include \masm32\include\gdi32.inc

        includelib \masm32\lib\user32.lib
        includelib \masm32\lib\kernel32.lib
        includelib \masm32\lib\gdi32.lib

WinMain		PROTO :DWORD, :DWORD, :DWORD, :SDWORD     	
ScrollProc	PROTO :DWORD, :DWORD, :DWORD, :DWORD

.data

ClassName db "SimpleWinClass",0
AppName   db "Colour Mixer",0

colour		dd	3 DUP (0)		; Primary colour values
crPrim		dd	0FFh, 0FF00h, 0FF0000h	; Define initial RGB primary colours 
Fmt	  	db 	"%i",0			; Format control for wsprintf 

szStatic	db	"static",0
szScrollbar	db	"scrollbar",0
szInitial	db	"0",0			; Initial colour value for all 3 colours 

szRed		db	"Red",0
szGreen		db	"Green",0
szBlue		db	"Blue",0
ColourLabel	dd	szRed, szGreen, szBlue
	
.data?

hInstance HINSTANCE ?
CommandLine LPSTR ?

rcColour	RECT	<>

cxClient	dd	?
cxClient_over2	dd	?
cxClient_over7	dd	?
cxClient_over14 dd	?
cxClient_over28 dd	?

cyClient	dd	?

cyChar		dd	?
cyCharOver2	dd	?

hBrush		dd	3 DUP (?)
hBrushStatic	dd	3 DUP (?)
hwndScroll	dd	3 DUP (?)
hwndLabel	dd	3 DUP (?)
hwndValue	dd	3 DUP (?)
OldScroll	dd	3 DUP (?)

hwndRect	dd	?
idFocus		dd	?
	
;Macros

LOWORD	MACRO 	bigword	;; Retrieves the low word from double word argument

	mov	eax,bigword
	and	eax,0FFFFh	;; Set to low word 
	ENDM

HIWORD	MACRO bigword  		;; Retrieves the high word from double word 

	mov	eax,bigword
	shr	eax,16		;; Shift 16 for high word to set to high word
	ENDM

MAX	MACRO   word1, word2	;; Return the maximum of 2 integers in eax

	mov	eax,word1
	.IF	eax < word2
	mov	eax,word2	;; Set word2 as max
	.ENDIF
	ENDM

MIN	MACRO	word1, word2	;; Return the minimum of 2 integers in eax

	mov	eax,word1
	.IF	eax > word2
	mov	eax,word2	;; Set word2 as min
	.ENDIF
	ENDM

M2M 	MACRO M1, M2		;; Copy word from memory to memory
        push M2
        pop  M1
        ENDM

RGB	MACRO red, green, blue	;; Get composite number from red green and blue bytes 

	mov	al,blue			;; ,,,blue	
	shl	eax,8			;; ,,blue,

	add	al,green		;; ,,blue,green
	shl	eax,8			;; ,blue,green,
	add	al,red			;; ,blue,green,red
	and	eax,0FFFFFFh		;; Mask out top byte to complete COLORREF dword 
	ENDM
	
return  MACRO arg

        mov eax, arg
        ret
        ENDM

;----------------------------------------------------------------------------
.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
        invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:SDWORD

LOCAL wc:WNDCLASSEX, msg:MSG, hwnd:HWND 

	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_BYTEALIGNCLIENT or CS_BYTEALIGNWINDOW  ; Use to avoid redraw flicker
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
        M2M   wc.hInstance, hInst
	invoke CreateSolidBrush,0
	mov   wc.hbrBackground,eax 
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
        invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
        mov   wc.hIconSm,0
        invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax 

        invoke RegisterClassEx, addr wc

        invoke CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
           hInst,NULL
        mov   hwnd,eax

        invoke ShowWindow, hwnd,CmdShow
        invoke UpdateWindow, hwnd

        .WHILE TRUE
                INVOKE GetMessage, ADDR msg,NULL,0,0
                .BREAK .IF (!eax)
                INVOKE TranslateMessage, ADDR msg
                INVOKE DispatchMessage, ADDR msg
        .ENDW

        return  msg.wParam
WinMain endp

WndProc proc uses esi edi, hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

LOCAL   hInst:DWORD, szBuffer[10]:byte

	mov	szBuffer[0],0			; Intially the buffer is empty 
	      
	mov   eax,uMsg
	
        .IF eax==WM_CREATE

		invoke  GetWindowLong, hWnd, GWL_HINSTANCE
		mov	hInst,eax

;	Create a white-rectangle window against which the scroll bars will be positioned
;	The child window ID is 9

		invoke  CreateWindowEx, NULL, ADDR szStatic, 0, WS_CHILD or WS_VISIBLE or \
			SS_WHITERECT, 0,0,0,0, hWnd, 9, hInst, 0
		mov	hwndRect,eax

		mov	esi, 0

		.WHILE  esi < 3
			
;		    The 3 child windows have ID's 0,1 & 2, and the scroll bars range
;		    from  0 to 255

		    push   esi
	
		    mov    edi, esi
		    shl	   esi, 2			; Form dword index
	   	   
		    invoke CreateWindowEx, NULL, ADDR szScrollbar, 0, WS_CHILD or \
			   WS_VISIBLE or WS_TABSTOP or SBS_VERT, 0,0,0,0,  \
			   hWnd, edi, hInst, 0

		    mov    hwndScroll[esi], eax

		    invoke SetScrollRange, hwndScroll[esi], SB_CTL, 0, 255, FALSE
		    invoke SetScrollPos,   hwndScroll[esi], SB_CTL, 0, FALSE

;		    The three colour name labels have ID's 3,4 & 5 and the text strings
;		    are "Red", "Green" and "Blue" (addresses are in ColourLabel) 

		    add	   edi, 3
	
		    invoke CreateWindowEx,NULL, ADDR szStatic, ColourLabel[esi], \
			   WS_CHILD or WS_VISIBLE or SS_CENTER, \
			   0,0,0,0, hWnd, edi, hInst, 0

		    mov    hwndLabel[esi], eax

;		    The three colour value text fields have ID's 6,7 & 8 
;		    and initial text strings of "0"

 		    add    edi, 3

		    invoke CreateWindowEx,NULL, ADDR szStatic, ADDR szInitial, \
			   WS_CHILD or WS_VISIBLE or SS_CENTER, \
			   0,0,0,0, hWnd, edi, hInst, 0

		    mov    hwndValue[esi], eax

;		    Set a new procedure for the scroll bars using "SetWindowLong"
;		    This technique is referred to as "windows subclassing"	 

		    invoke SetWindowLong, hwndScroll[esi], GWL_WNDPROC, ADDR ScrollProc

		    mov    OldScroll[esi], eax	; Save address of existing scroll bar proc 

		    invoke CreateSolidBrush, crPrim[esi]	; Create scroll bar brushes
		    mov    hBrush[esi], eax			; from primary colours
 		
		    pop    esi
		    inc	   esi

		.ENDW

		invoke	GetSysColor, COLOR_BTNHIGHLIGHT
		invoke  CreateSolidBrush, eax
		mov	hBrushStatic, eax

		invoke  GetDialogBaseUnits
		HIWORD  eax
		mov	cyChar, eax

		shr	eax,1
		mov	cyCharOver2,eax
		
		return  0

	.ELSEIF eax==WM_SIZE

		LOWORD	lParam
		mov	cxClient, eax

		mov	ecx, eax
		shr	ecx,1
		mov	cxClient_over2, ecx		; cxClient/2

		mov	ecx,7
		mov	edx,0
		div	ecx
		mov	cxClient_over7, eax		; cxClient/7 
		shr	eax,1
		mov	cxClient_over14, eax		; cxClient/14
		shr	eax,1
		mov	cxClient_over28, eax		; cxClient/28

		HIWORD	lParam
		mov	cyClient, eax

		invoke  SetRect, ADDR rcColour, cxClient_over2, 0, cxClient, cyClient
		invoke	MoveWindow, hwndRect, 0,0, cxClient_over2, cyClient, TRUE

		mov	edi,0

		.WHILE  edi < 3

			mov	esi, edi
			shl	esi,2			; Get dword index

			mov	eax, edi
			shl	eax, 1
			inc	eax
			mov	edx,0
			mul	cxClient_over14		; (2*i + 1)*cxClient/14;  in eax
		
			mov	ecx, cyClient
			mov	edx, cyChar
			shl	edx, 1			; 2*cyChar
			sub	ecx, edx		
 			sub	ecx, edx		; cyClient - 4*cyChar

			invoke  MoveWindow, hwndScroll[esi], eax, edx, \
				cxClient_over14, ecx, TRUE

			mov	eax, edi
			shl	eax, 2
			inc	eax
			mov	edx,0
			mul	cxClient_over28		; (4*i + 1)*cxClient/28;  in eax
		
			invoke  MoveWindow, hwndLabel[esi], eax, cyCharOver2, \
				cxClient_over7, cyChar, TRUE

			mov	eax, edi
			shl	eax, 2
			inc	eax
			mov	edx,0
			mul	cxClient_over28		; (4*i + 1)*cxClient/28;  in eax
		
			mov	ecx,cyClient
			sub	ecx,cyChar
			sub	ecx,cyCharOver2		; cyClient - (3/2)*cyChar   
		
			invoke  MoveWindow, hwndValue[esi], eax, ecx, \
				cxClient_over7, cyChar, TRUE
	
			inc     edi			   
		.ENDW

  		invoke	SetFocus, hWnd
		return  0

	.ELSEIF eax==WM_SETFOCUS		; Set focus to appropriate window

		mov	esi, idFocus
		invoke  SetFocus, hwndScroll[esi]
		return  0

	.ELSEIF eax==WM_VSCROLL			; Control vertical scroll

		invoke  GetWindowLong, lParam, GWL_ID
		mov	esi, eax
		shl	esi,2			; form dword index

		LOWORD	wParam
		
		.IF     eax==SB_PAGEDOWN

		    add	colour[esi], 15

		.ELSEIF eax==SB_LINEDOWN

		    mov eax, colour[esi]
		    inc	eax	
		    MIN 255, eax
		    mov colour[esi], eax

		.ELSEIF eax==SB_PAGEUP

		    sub	colour[esi], 15

		.ELSEIF eax==SB_LINEUP

		    mov eax, colour[esi]	; Get the R,G or B primary colour value
		    dec	eax
		    MAX 0, eax
		    mov colour[esi], eax

		.ELSEIF eax==SB_TOP		; Translated by Windows from Home key

		    mov colour[esi],0

		.ELSEIF eax==SB_BOTTOM		; Translated by Windows from End key

		    mov colour[esi], 255

		.ELSEIF eax==SB_THUMBPOSITION || eax==SB_THUMBTRACK

		    HIWORD wParam
		    mov colour[esi], eax

		.ENDIF

		invoke SetScrollPos, hwndScroll[esi], SB_CTL, colour[esi], TRUE

		invoke  wsprintf, ADDR szBuffer, ADDR Fmt, colour[esi]  ; Colour val to buffer 

		invoke  SetWindowText, hwndValue[esi], ADDR szBuffer	; Change colour value

		mov	cl,byte ptr colour[0]
		mov	ch,byte ptr colour[1*4]
		mov	dl,byte ptr colour[2*4]
		RGB	cl,ch,dl			; Generate COLORREF value
		 
		invoke CreateSolidBrush, eax
		invoke SetClassLong, hWnd, GCL_HBRBACKGROUND, eax
		invoke DeleteObject, eax

		invoke InvalidateRect, hWnd, ADDR rcColour, TRUE 	; Show the new colour 

		return 0

	.ELSEIF eax==WM_CTLCOLORSCROLLBAR	; Colour the scroll bars red, green and blue 	

		invoke  GetWindowLong, lParam, GWL_ID	; Get ID of the scroll bar  
		mov	esi, eax
		shl	esi,2			; Form Dword index

		return  hBrush[esi]		; Return the relevant brush

	.ELSEIF eax==WM_CTLCOLORSTATIC		; Colour the static text ; 3 @ top, 3 @ bottom

		invoke  GetWindowLong, lParam, GWL_ID
		mov	esi, eax

		.WHILE  esi >= 3 && esi <= 8	; Static text controls

		        mov  eax, esi
		        mov  ecx,3
			mov  edx,0	
		        div  ecx
		        mov  edi, edx		; Got modulus 3
			shl  edi,2		; make dword index
		 	
		        invoke SetTextColor, wParam, crPrim[edi]
		        invoke GetSysColor, COLOR_BTNHIGHLIGHT
		        invoke SetBkColor, wParam, eax

		        return hBrushStatic
			inc  esi	
		.ENDW
	
	.ELSEIF eax==WM_SYSCOLORCHANGE		; Recreate hBrushStatic using new colour

		invoke  DeleteObject, hBrushStatic
		invoke  GetSysColor, COLOR_BTNHIGHLIGHT
		invoke  CreateSolidBrush, eax
		mov	hBrushStatic, eax
		return  0
		
	.ELSEIF eax==WM_DESTROY

		invoke GetStockObject, WHITE_BRUSH
		invoke SetClassLong, hWnd, GCL_HBRBACKGROUND, eax
		invoke DeleteObject, eax	       

		mov	esi, 0

		.WHILE  esi < 3*4
			invoke  DeleteObject, hBrush[esi]
			add  esi, 4	
		.ENDW

		invoke  DeleteObject, hBrushStatic
		invoke  PostQuitMessage,0

		return  0
        .ENDIF
                invoke  DefWindowProc,hWnd,uMsg,wParam,lParam

                return  eax
	
WndProc endp

ScrollProc	proc uses esi, hwnd:HWND, message:UINT, wParam:WPARAM, lParam:LPARAM

;		This does preliminary scroll bar message processing
;		---------------------------------------------------

LOCAL	ID:DWORD

	invoke  GetWindowLong, hwnd, GWL_ID
	mov	ID, eax
 
	mov	eax, message

	.IF	eax==WM_KEYDOWN

		mov eax, VK_TAB
	
	    .IF wParam==eax
 	
		invoke  GetKeyState, VK_SHIFT

		.IF  eax < 0
		    mov eax, 2	
		.ELSE
		    mov eax, 1
		.ENDIF

		add	eax, ID			; ID + (2 or 1)
	
		mov     ecx, 3
		mov     edx, 0
		div     ecx			; Get modulus 3 in edx
		push	edx
					
		invoke  GetParent, hwnd
		pop	edx
		invoke  GetDlgItem, eax, edx
		invoke  SetFocus, eax

	    .ENDIF

	.ELSEIF eax==WM_SETFOCUS

		M2M	idFocus, ID  

	.ENDIF
		mov	esi,ID
		shl	esi, 2			; Form Dword index

;		Pass message to specified window proc; OldScroll is addr of previous proc

		invoke  CallWindowProc, OldScroll[esi], hwnd, message, wParam, lParam

	return  eax

ScrollProc	endp

        end start

